.386
.model flat,stdcall
option casemap:none
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
MatrProd proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

include D:\masm32\include\windows.inc
include D:\masm32\include\user32.inc
include D:\masm32\include\kernel32.inc
include D:\masm32\include\masm32.inc
include D:\masm32\macros\macros.asm

includelib D:\masm32\lib\user32.lib
includelib D:\masm32\lib\kernel32.lib
includelib D:\masm32\lib\masm32.lib

.data
ClassName  db "SimpleWinClass",0
AppName    db " ",0
MenuName   db "MainMenu",0
EditClass  db "Edit",0
str11      db ", ",0

MatrixA    DD 1, 1, 1
           DD 1, 1, 1
           DD 1, 1, 1
     
MatrixB    DD 1, 1, 1
           DD 1, 1, 1
           DD 1, 1, 1
     
MatrixC    DD 0, 0, 0
           DD 0, 0, 0
           DD 0, 0, 0
     
CB         DD 3
RA         DD 3
CRAB       DD 3

.data?
hInstance     HINSTANCE  ?
hwndEdit      HWND       ?
CommandLine   LPSTR      ?
buf11         DWORD      ?

.const
EditID      equ 1
IDM_MULTIN  equ 1
IDM_MULTOUT equ 2
IDM_OUTP    equ 3
IDM_EXIT    equ 4

.code
start:
  invoke GetModuleHandle, NULL
  mov    hInstance,eax
  invoke GetCommandLine
  invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
  invoke ExitProcess,eax
  
;_________________________________________________________________________

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
  LOCAL wc:WNDCLASSEX
  LOCAL msg:MSG
  LOCAL hwnd:HWND
  mov   wc.cbSize,SIZEOF WNDCLASSEX
  mov   wc.style, CS_HREDRAW or CS_VREDRAW
  mov   wc.lpfnWndProc, OFFSET WndProc
  mov   wc.cbClsExtra,NULL
  mov   wc.cbWndExtra,NULL
  push  hInst
  pop   wc.hInstance
  mov   wc.hbrBackground,COLOR_BTNFACE+1
  mov   wc.lpszMenuName,OFFSET MenuName
  mov   wc.lpszClassName,OFFSET ClassName
  invoke LoadIcon,NULL,IDI_APPLICATION
  mov   wc.hIcon,eax
  mov   wc.hIconSm,eax
  invoke LoadCursor,NULL,IDC_ARROW
  mov   wc.hCursor,eax
  invoke RegisterClassEx, addr wc
  INVOKE CreateWindowEx, WS_EX_CLIENTEDGE, ADDR ClassName, ADDR AppName,\
           WS_OVERLAPPEDWINDOW, CW_USEDEFAULT,\
           CW_USEDEFAULT, 400, 250, NULL, NULL,\
           hInst,NULL
  mov   hwnd,eax
  
  INVOKE ShowWindow, hwnd,SW_SHOWNORMAL
  INVOKE UpdateWindow, hwnd
  .WHILE TRUE
                INVOKE GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                INVOKE TranslateMessage, ADDR msg
                INVOKE DispatchMessage, ADDR msg
  .ENDW
  mov     eax,msg.wParam
  ret
WinMain endp

;_______________________________________________________________

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
  .IF uMsg==WM_DESTROY
    invoke PostQuitMessage,NULL
  .ELSEIF uMsg==WM_CREATE
    INVOKE CreateWindowEx, WS_EX_CLIENTEDGE, ADDR EditClass, NULL,\
           WS_CHILD or WS_VISIBLE or WS_BORDER or ES_LEFT or ES_AUTOHSCROLL,\
     0, 0, 380, 187, hWnd, EditID, hInstance, NULL
    mov hwndEdit, eax
    invoke SetFocus, hwndEdit
  .ELSEIF uMsg==WM_COMMAND
    mov eax,wParam
    .IF lParam==0
      .IF ax==IDM_MULTIN
     invoke MatrProd, addr MatrixA, addr MatrixB, addr MatrixC,
               RA, CB, CRAB
      .elseif ax==IDM_MULTOUT
      .elseif ax==IDM_OUTP
     invoke SendMessage, hwndEdit, WM_SETTEXT, NULL,addr buf11
      .else
        invoke DestroyWindow, hWnd
      .ENDIF
 .ENDIF
  .ELSE
    invoke DefWindowProc, hWnd, uMsg,wParam,lParam
    ret
  .ENDIF
  xor    eax,eax
  ret
WndProc endp
;_______________________________________________________

MatrProd proc MAAd: DWORD, MBAd: DWORD, MCAd: DWORD, 
              RowA: DWORD, CalB: DWORD, CaRoAB: DWORD 
  LOCAL NeRA: DWORD
  LOCAL NeCB: DWORD
  LOCAL NexCR: DWORD
  
  mov NeRA,0
  mov NeCB,0
  mov NexCR,0 
  .WHILE TRUE
    .WHILE TRUE;     [],0
      ;---mov MCAd[NeRA*CalB+NeCB],0
      ;---[i,j]:=0
      ;---i=NeRA*CalB (    )
      ;---j=NeCB
   
   invoke IntMul, NeRA, CalB
      mov ebx, NeCB
      add eax, ebx
   mov ebx, DWORD PTR 4
   invoke IntMul, eax, ebx
      mov ebx, MCAd
      add eax, ebx
      mov [eax],DWORD PTR 0
 
        .WHILE TRUE
    ;mov eax, MBAd[NexCR*CalB+NeCB]
          invoke IntMul, NexCR, CalB
          mov ebx, NeCB
          add eax, ebx
       mov ebx, DWORD PTR 4
          invoke IntMul, eax, ebx
          mov ebx, MBAd
          add eax, ebx
    mov ebx, [eax]
    mov eax, ebx
    
    push eax
    
    ;mov ebx, MAAd[NeRA*CaRoAB+NexCR]
    invoke IntMul, NeRA, CaRoAB
          mov ebx, NexCR
          add eax, ebx
          mov ebx, DWORD PTR 4
          invoke IntMul, eax, ebx
          mov ebx, MAAd
          add eax, ebx
    mov ebx, [eax]
    
    pop eax
    invoke IntMul, eax, ebx
    push eax
    
    ;add MCAd[NeRA*CalB+NeCB],edx
          ;add MCAd[NeRA*CalB+NeCB],eax 
    invoke IntMul, NeRA, CalB
          mov ebx, NeCB
          add eax, ebx
          mov ebx, DWORD PTR 4
          invoke IntMul, eax, ebx
          mov ebx, MCAd
          add ebx, eax
    pop eax
    add [ebx],eax

       invoke dwtoa, eax, ADDR buf11
    invoke lstrcat,addr buf11,addr str11
    
    mov eax, NexCR
    mov ebx, CaRoAB 
       .BREAK .IF eax==ebx 
          inc NexCR
  .ENDW
   mov eax, NeCB
   mov ebx, CalB 
   .BREAK .IF eax==ebx 
      inc NeCB
 .ENDW
 mov eax, NeRA
 mov ebx, RowA 
 .BREAK .IF eax==ebx 
 inc NeRA
  .ENDW  
  ret
MatrProd endp

;___________________________________________________

end start
